import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { OaAppRenew, OaAppRenewParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询续费管理
 */
export async function pageOaAppRenew(params: OaAppRenewParam) {
  const res = await request.get<ApiResult<PageResult<OaAppRenew>>>(
    MODULES_API_URL + '/oa/oa-app-renew/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询续费管理列表
 */
export async function listOaAppRenew(params?: OaAppRenewParam) {
  const res = await request.get<ApiResult<OaAppRenew[]>>(
    MODULES_API_URL + '/oa/oa-app-renew',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加续费管理
 */
export async function addOaAppRenew(data: OaAppRenew) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-renew',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改续费管理
 */
export async function updateOaAppRenew(data: OaAppRenew) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-renew',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除续费管理
 */
export async function removeOaAppRenew(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-renew/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除续费管理
 */
export async function removeBatchOaAppRenew(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-renew/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询续费管理
 */
export async function getOaAppRenew(id: number) {
  const res = await request.get<ApiResult<OaAppRenew>>(
    MODULES_API_URL + '/oa/oa-app-renew/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
